#
# spec file for package pnp4nagios 
#
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#


Name:           pnp4nagios
%define         realname pnp4nagios
Summary:        Tool for producing graphs from Nagios perfdata
Version:        0.6.1
Release:        1.22
Url:            http://www.ederdrom.de/pnp/start
License:        GPL v2 or later
Group:          System/Monitoring
BuildRequires:  apache2-devel
BuildRequires:  nagios-www
BuildRequires:  kohana
Requires:       kohana
Requires:       nagios-www
Requires:       rrdtool
Requires:       syslog
Requires:       perl
Recommends:     dejavu
#
%if 0%{?mandriva_version}
# break the "have choice for" cycle
BuildRequires:  apache-mpm-prefork
BuildRequires:  mailx
%endif
#
%if 0%{?suse_version}
Requires:       php-zlib
Requires:       php-gd
%endif
%if 0%{suse_version} > 1020
BuildRequires:  fdupes
BuildRequires:  rrdtool-devel
%else
BuildRequires:  rrdtool
%endif
Source0:        %realname-%version.tar.bz2
Source1:        %name-httpd.conf
Source2:        %name.quick-start.txt
Source3:        %name-init
Source4:        pnp4nagios-rpmlintrc
Source5:        pnp4nagios-nagios-pnp.cfg
Source6:        pnp4nagios-check_nrpe.cfg
Patch1:         pnp4nagios-0.6.1-check_pnp_rrds.patch
Patch2:         pnp4nagios-0.6.1-verify_pnp_config.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%define         nsusr nagios
%define         nsgrp nagios
%define         apxs2 /usr/sbin/apxs2-prefork
%define         apache2_sysconfdir %(%{apxs2} -q SYSCONFDIR)
%define         libexecdir %_prefix/lib/nagios/plugins
%define         perfdata_spooldir /var/spool/nagios-pnp

%description
PNP is a tool that produces graphs from performance data from
Nagios plugins.

Authors:
--------
    Jörg Linge
    Hendrik Bäcker	


%prep
%setup -q -n %realname-%version
%patch1 -p0
%patch2 -p0

%build
%configure \
    --datadir=%_datadir/pnp \
    --datarootdir=%_datadir/pnp/html \
    --localstatedir=/var/log/nagios/pnp \
    --sysconfdir=%_sysconfdir/nagios/pnp \
    --libexecdir=%libexecdir \
    --datarootdir=%_datadir/pnp \
	--with-perfdata-logfile=/var/log/nagios/pnp/perfdata.log \
    --with-perfdata-dir=/var/lib/nagios/pnp \
    --with-perfdata-spool-dir=%{perfdata_spooldir} \
    --with-init-dir=%_sysconfdir/init.d \
    --with-nagios-user=%nsusr \
    --with-nagios-group=%nsgrp \
    --without-kohana \
    --with-kohana_system=/usr/share/kohana/system
make %{?jobs:-j%jobs} all

%install
mkdir -p %buildroot/var/lib/nagios/pnp %buildroot/var/log/nagios/pnp
make install install-config \
    DESTDIR="%buildroot" \
    LIBEXEC_DIR="%libexecdir" \
    INSTALL_OPTS=""
# move samples to the docudir
mkdir -p %buildroot/%_defaultdocdir/%name/sample-config
find sample-config/ -name "*-sample*" -exec cp -v {} %buildroot/%_defaultdocdir/%name/sample-config/ \;
# install config files not installed via Makefile
sed -e 's@/usr/local/nagios/var/npcd.log@/var/log/nagios/pnp/npcd.log@' \
    -e 's@/usr/var/perfspool/@%{perfdata_spooldir}@' \
    -e 's@/usr/local/nagios/libexec/process_perfdata.pl@%libexecdir/process_perfdata.pl@' \
	-e 's@/usr/libexec@%libexecdir@' \
    %buildroot/%_sysconfdir/nagios/pnp/npcd.cfg-sample > %buildroot/%_sysconfdir/nagios/pnp/npcd.cfg
mv %buildroot/%_sysconfdir/nagios/pnp/process_perfdata.cfg-sample %buildroot/%_sysconfdir/nagios/pnp/process_perfdata.cfg
mv %buildroot/%_sysconfdir/nagios/pnp/rra.cfg-sample %buildroot/%_sysconfdir/nagios/pnp/rra.cfg
sed -e 's@\^hna0@localhost@' \
    -e 's@\^traffic@traffic@' \
    %buildroot/%_sysconfdir/nagios/pnp/pages/web_traffic.cfg-sample > %buildroot/%_sysconfdir/nagios/pnp/pages/web_traffic.cfg
mv %buildroot/%_sysconfdir/nagios/pnp/check_commands/check_nwstat.cfg-sample %buildroot/%_sysconfdir/nagios/pnp/check_commands/check_nwstat.cfg
install -m644 %{SOURCE6} %buildroot/%_sysconfdir/nagios/pnp/check_commands/check_nrpe.cfg
find %buildroot/%_sysconfdir/nagios/pnp -name "*-sample" -exec rm {} \;
# fix pathname to the kohana files
sed -i "s|^\$kohana_modules.*|\$kohana_modules = '/usr/share/kohana/modules';|" %buildroot/%_datadir/pnp/index.php
rm %buildroot/%_datadir/pnp/install.php
# install own nagios command file
install -m644 %{SOURCE5}  %buildroot/%_sysconfdir/nagios/nagios-pnp.cfg
# install the documentation
mkdir -p %buildroot/%_defaultdocdir/%name
install -m0644 AUTHORS ChangeLog COPYING README* THANKS %buildroot/%_defaultdocdir/%name/
install -m0644 %{S:2} %buildroot/%_defaultdocdir/%name/README.SuSE
# install contrib scripts into docdir
mkdir -p %buildroot/%_defaultdocdir/%name/example
# install template placeholder
mkdir -p %buildroot/%_datadir/pnp/templates/
touch %buildroot/%_datadir/pnp/templates/PUT-YOUR-TEMPLATES-HERE
# install directories
install -d -m0775 %buildroot/%{perfdata_spooldir}
install -d -m0775 %buildroot/var/log/nagios/pnp/stats
# install apache configuration
install -d -m 0755 %buildroot/%{apache2_sysconfdir}/conf.d/
install -m0644 %{SOURCE1} %buildroot/%{apache2_sysconfdir}/conf.d/nagios-pnp.conf
# install init-script
mkdir -p %buildroot/%_sysconfdir/init.d
install -m0755 %{SOURCE3} %buildroot/%_sysconfdir/init.d/npcd
mkdir -p %buildroot/%_sbindir
ln -s %_sysconfdir/init.d/npcd %buildroot/%_sbindir/rcnpcd
# save discspace, create links
%if 0%{suse_version} > 1020
%fdupes -s %buildroot/%_datadir/pnp
%endif

%clean
rm -rf %buildroot

%preun
%stop_on_removal npcd

%postun
%insserv_cleanup npcd

%files
%defattr(-,root,root)
%doc %_defaultdocdir/%name/
%dir %_datadir/pnp
%dir %_sysconfdir/nagios/pnp
%attr(-,%nsusr,%nsgrp) %dir %{perfdata_spooldir}
%attr(-,%nsusr,%nsgrp) %dir /var/log/nagios/pnp
%attr(-,%nsusr,%nsgrp) %dir /var/log/nagios/pnp/stats
%{_bindir}/*
%_datadir/pnp/*
%attr(0755,root,root) %libexecdir/*
# %{_mandir}/man1/*
%_sbindir/rcnpcd
%_sysconfdir/init.d/npcd
%config(noreplace) %_sysconfdir/nagios/pnp/*
%config(noreplace) %apache2_sysconfdir/conf.d/nagios-pnp.conf
#%config(noreplace) %_sysconfdir/xinetd.d/nagios-pnp
%config(noreplace) %_datadir/pnp/templates/*
%config(noreplace) %_sysconfdir/nagios/nagios-pnp.cfg
%defattr(775,wwwrun,www)
%_datadir/pnp/application/cache
%_datadir/pnp/application/logs

%changelog
* Tue Dec 15 2009 lars@linux-schulserver.de
- update to 0.6.1
  + Webfrontend based on http://www.kohanaphp.com (separate package)
  + Javascript-functions using jQuery plugins
  + process_perfdata.pl will be able to use one RRD database
    per datasource
  + RRDtool errors are now displayed as images. no more missing images
  + PNP templates cannot overwrite internal variables anymore
  + PNP templates of version 0.4.x can still be used
  + PDF functions recoded
  + Template default.php optimized
  + Export from RRD databases into XML, CSV and JSON format using the
    RRDtool "xport" function
  + Page functions recoded
  + Error pages links to online FAQ
  + Mouseover Popup in Nagios frontend via jQuery.clueTip plugin
  + Full support of rrdcached
  + RRD heartbeat per check_command -> tpl_custom
  + New config.php option pdf_graph_opt
  + Recognize the 'background_pdf' option in page definitions
  + Recognize the 'source' option in page definitions
  + Array $TIMERANGE now available for templates
  + Store internal runtime statistics on a per minute base
  + Added two widgets views/widget_menu.php and views/widget_graph.php
- improved apache include config
- pnp4nagios requires kohana now
* Thu Jul 23 2009 lars@linux-schulserver.de
- update to 0.4.14:
  + Use Nagios TIMET Macro while creating new RRD Databases.
  + New config option enable_recursive_template_search.
  + Better signal handling in process_perfdata.pl
  + FIX: Optimized check_multi detection.
  + FIX: Popups are now working with IE.
  + RRA config per check_command.
- recommend dejavu
* Tue Mar 17 2009 lars@linux-schulserver.de
- enhance the command template for users using NPCD to process
  their performance data.
* Fri Feb 20 2009 lars@linux-schulserver.de
- update to 0.4.13:
  + Overlib 4.21 included http://www.bosrup.com/web/overlib/
  + Prototype Ajax Framework 1.6.0.3 included http://www.prototypejs.org/
  + Script.aculo.us Update to 1.8.1
  + FIX: Function rrd_fetch renamed to rrdtool_fetch to avoid
    naming conflict
  + Experimental: New npcd Event Broker Module - handle with care
  + Experimental: New special templates stored in templates.special
  + FIX: autoconf detection for getloadavg() - ignore
    loadthreshold if not available
  + FIX: Host OS Detection for mod_cflags/mod_ldflags
* Tue Oct 28 2008 lars@linux-schulserver.de
- update to 0.4.12:
  + Remove Call-time pass-by-reference
  + FIX: Fixed wrong check_multi service description
  + FIX: Fixed page config parser
* Fri Aug 29 2008 lars@linux-schulserver.de
- add <IfDefine PNP4NAGIOS> to the apache configuration to
  avoid startup problems if SSL is enabled and no SSLKey is
  available for this config.
* Wed Jul 16 2008 lars@linux-schulserver.de
- update to 0.4.10:
  + BUGFIX: Fixed wrong link to avail.cgi used on pages.
  + BUGFIX: Don´t exit process_perfdata.pl when process_perfdata.cfg
    is missig.
  + Report missing RRDs Perl Modules.
* Fri May 16 2008 lars@linux-schulserver.de
- update to 0.4.9:
  + process_perfdata.pl results in timeouts and broken XML files
    caused by missing RRDs Perl Modules
- removed pnp-0.4.7-buffer_overflow.patch
* Thu May  1 2008 lars@linux-schulserver.de
- update to 0.4.8:
  + New process_perfdata.pl option -c [–config] to specify an
    alternate config file.
  + France Translation added by Jean-Marie Le Borgne
  + XML Encoding can now be changed by using XML_ENC in
    process_perfdata.cfg
  + Set SetAutoPageBreak() in doPDF function.
  + New Option background_pdf can be used in page definitions to
    override the defaults.
  + process_perfdata.cfg: Option RRD_HEARTBEAT added.
  + New NPCD Option: sleep_time
  + Fixed process_perfdata.pl race condition: config file timeout
    now won't be ignored
  + Backslashes used in service descriptions are now substituted
    to underscores.
* Sat Apr 12 2008 lars@linux-schulserver.de
- fix directory ownership
- fix execute bits for process_perfdata.pl
- safe_mode must currently be off to keep it easily running
- added nagios-pnp.cfg containing command definitions
* Thu Mar 13 2008 lars@linux-schulserver.de
- update to 0.4.7:
  + Fixed compiler errors on Solaris
  + Switched to autoconf 2.61
  + Fixed is_file() on older SuSE releases
* Mon Feb 11 2008 lars@linux-schulserver.de
- update to 0.4.6:
  + XML Tag <RRD> reflects the last rrdtool returncode and text.
  + parse_xml() cleanup.
  + Improved check_multi support.
  + Calendar added to all views.
  + New Icons based on KDE Theme nuvoX.
  + Fixed libpng write errors.
  + Added suport for threshold range format
  + New Template check_snmp_int-bits.php.
    Output is displayed in Bits/s
  + NPCD now takes care about the exit status
    of the executed command
  + No more PID File creation without Daemon Mode
  + Load thresholding through config file (experimental)
  + No try to write PID File after a HUP Signal
  + File Log is now ready for testing
  + Rotation of logfile
  + New configure option: –with-perfdata-spool-dir
  + Stay in the current timerange when switching between pages
  + New Configure Option –with-init-dir
* Tue Dec 18 2007 lars@linux-schulserver.de
- initial release 0.4.3
